<script>
  import Footer from "./footer.svelte";
  import Social from "./social.svelte";

  let videos = [];
  fetch("videos.json")
    .then(d => d.json())
    .then(j => (videos = j));

  function play_video() {
    this.classList.add("playing");
    const video = this.querySelector(".video");
    video.setAttribute("src", video.dataset.src);
  }

  function scroll(e) {
    e.preventDefault();
    document
      .querySelector(this.getAttribute("href"))
      .scrollIntoView({ behavior: "smooth" });
  }

  const observer = new IntersectionObserver(onIntersect);
  const lazy = img => observer.observe(img);

  function onIntersect(entries) {
    for (let e of entries) {
      if (!e.isIntersecting) continue;

      let img = new Image();
      img.onload = _ => {
        e.target.src = img.src;
        e.target.classList.remove("lazy");
      };

      const id = e.target.closest(".item").id;
      img.src = `https://img.youtube.com/vi/${id}/maxresdefault.jpg`;
      observer.unobserve(e.target);
    }
  }
</script>

<style>
  #topbar {
    position: fixed;
    width: 100%;
    top: 0;
    background: #f90;
    z-index: 2;
    box-shadow: 0 0 2px #0004;
  }

  #topbar .content {
    display: flex;
    flex-flow: row nowrap;
    justify-content: center;
    align-items: center;

    max-width: 980px;
    margin: 0 auto;
    background: transparent;
    padding: 15px 15px;
  }
  #topbar h3 {
    margin: 0;
    color: #fff;
    letter-spacing: 0.5px;
  }

  #topbar button {
    color: #fff;
    background: #0006;
    border: none;
    padding: 5px 10px;
    cursor: pointer;
    margin-left: 20px;
  }
  #topbar .content:hover {
    text-decoration: none;
  }
  header {
    /* margin-top: 59px; */
    position: relative;
    padding: 79px 40px 60px;
    background-image: linear-gradient(to bottom, #001a 100%, #0000),
      url("../img/header.jpg");
    background-size: cover;
    background-position: center;
    text-align: center;
  }

  header::before,
  header::after {
    position: absolute;
    content: "";
    display: block;
    width: 50%;
    bottom: 0;
    border-bottom: 30px solid #e6f2ee;
    box-sizing: border-box;
  }
  header::before {
    left: 0;
    border-right: 50vw solid transparent;
  }
  header::after {
    right: 0;
    border-left: 50vw solid transparent;
  }
  .logo {
    max-width: 264px;
  }

  header .title {
    font-size: 190px;
    text-shadow: 0 1px 2px #0006;
    margin: 50px 0 0;
    text-transform: uppercase;
    color: #fff;
  }

  @media (max-width: 850px) {
    header {
      padding-left: 20px;
      padding-right: 20px;
    }
    header .title {
      font-size: 23vw;
    }
    header::before,
    header::after {
      border-bottom-color: #fff;
    }
  }

  main {
    max-width: 980px;
    padding: 50px 40px;
    margin: 0 auto;
  }

  #videos {
    font-size: 4em;
    margin-top: 0;
    margin-bottom: 10px;
  }

  .bio {
    padding-left: 12px;
  }

  .items {
    margin-top: 40px;
  }

  .item {
    margin-bottom: 40px;
  }

  .video_wrapper {
    position: relative;
    height: 100vh;
    max-height: 551px;
    overflow: hidden;
  }

  .thumbnail {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    object-fit: cover;
    cursor: pointer;
    transition: 100ms;
  }
  .thumbnail.lazy {
    filter: blur(5px);
  }
  .play_button {
    position: absolute;
    max-width: 100px;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    cursor: pointer;
  }

  .video {
    position: relative;
    visibility: hidden;
    width: 100%;
    height: 100%;
    z-index: 1;
  }

  :global(.playing .video) {
    animation: fade_in 400ms forwards;
  }

  .quick_actions {
    float: right;
    display: flex;
    width: 180px;
    max-width: 100vw;
    flex-flow: row nowrap;
    justify-content: flex-end;
    align-items: center;
    margin-top: 10px;
  }

  .subscribe {
    position: relative;
    display: inline-block;
    width: 24px;
    overflow: hidden;
    transition: width 400ms;
    text-align: left;
    cursor: pointer;
  }

  .subscribe::after {
    position: absolute;
    font-weight: 500;
    letter-spacing: 0.5px;
    margin-left: 5px;
    color: #5a5862;
  }

  .subscribe {
    margin-left: 10px;
  }

  .subscribe::after {
    content: "Subscribe";
  }

  .quick_actions:hover .subscribe {
    width: 100px;
  }

  .content {
    background: #fff;
    padding: 40px 40px 20px;
  }

  .description {
    margin: 0 5px 0 0;
  }

  .video_title {
    font-size: 36px;
  }

  .middle {
    display: flex;
    flex-flow: row nowrap;
    justify-content: flex-start;
    align-items: flex-start;
  }

  .related_grid {
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(250px, 286px));
    grid-gap: 20px;
    margin-top: 20px;
  }

  .related {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: flex-start;
    max-width: 300px;
    transition: transform 200ms;
  }

  .related:hover {
    transform: scale(1.05);
    text-decoration: none;
  }

  .related img {
    border-radius: 2px;
    width: 100%;
    object-fit: cover;
  }
  .related .title {
    font-size: 1.2em;
    color: #5a5862;
    margin-top: 7px;
  }

  .download {
    background: #1c9671;
    padding: 15px 30px;
    margin-top: 10px;
    color: #fff;
    transition: transform 200ms;
  }

  .download:hover {
    transform: scale(1.05);
  }

  .bottom {
    margin: 25px 0 40px;
    display: flex;
    flex-flow: row wrap;
    justify-content: space-between;
    align-items: flex-end;
  }

  .more {
    display: block;
    margin: 50px 0 0;
    text-align: center;
    font-size: 30px;
    font-weight: 400;
  }

  @keyframes fade_in {
    0% {
      visibility: hidden;
    }
    1% {
      visibility: visible;
      opacity: 0;
    }
    100% {
      visibility: visible;
      opacity: 1;
    }
  }

  @media (max-width: 1060px) {
    .video_wrapper {
      max-height: calc(9 / 16 * (100vw - 80px));
    }
  }

  @media (max-width: 850px) {
    #videos {
      padding: 0 15px;
    }

    .bio {
      padding: 0 25px;
    }

    .online-class {
      margin-bottom: 5px;
    }
    .video_wrapper {
      max-height: calc(9 / 16 * 100vw);
    }
    main {
      padding-left: 0;
      padding-right: 0;
    }
  }

  @media (max-width: 800px) {
    .top {
      display: flex;
      flex-flow: column nowrap;
      justify-content: flex-start;
      align-items: flex-start;
    }

    .quick_actions {
      order: 2;
      margin: 0;
      width: auto;
    }

    .quick_actions:hover .subscribe {
      width: auto;
    }

    .middle {
      flex-flow: column nowrap;
      align-items: flex-start;
    }

    .subscribe {
      position: static;
      width: auto;
      margin: 0;
    }
  }
</style>

<!-- <div id="topbar">
  <a class="content" href="#footer" on:click={scroll}>
    <h3>GET 10% OFF IMMUNE BOOSTING PROGRAMS</h3>
    <button>Get Discount</button>
  </a>
</div> -->
<header>
  <img
    class="logo"
    src="img/logo-light.svg"
    alt="Wildwood Lifestle Center Logo" />
  <h1 class="title">DIY Health</h1>
</header>
<main>
  <h2 id="videos">Videos</h2>
  <div class="bio">
    <p>
      DIY Health by Wildwood Lifestyle Center is your platform for plant-based
      cooking hacks, natural remedies, and health tips that anyone can
      understand. Whether you are a home remedy veteran or just want to see what
      the buzz is all about, you're going to love these videos, guaranteed! Now
      what are you waiting for? Scroll down to start your journey towards a
      healthier lifestyle.
    </p>
    <h3 class="online-class">Learn more</h3>
    <p>
      Want to dive deeper into natural remedies? Wildwood’s Health Evangelism
      Online course is a convenient and cost-effective training designed for
      those who have a fire burning within to share the health message with the
      world and help others through it. Thousands have gone before you. What are
      you waiting for?
    </p>
    <a
      class="button download"
      href="https://healthevangelism.com/courses/health-evangelism-online/"
      target="_blank">
      Tell Me More
    </a>
  </div>

  <div class="items">
    {#each videos as video}
      <div id={video.id} class="item">
        <div class="video_wrapper" on:click|once={play_video}>
          <iframe
            class="video"
            data-src="https://www.youtube-nocookie.com/embed/{video.id}?autoplay=1&rel=0"
            allowfullscreen=""
            title={video.title}
            frameborder="0" />
          <img
            use:lazy
            src="https://img.youtube.com/vi/{video.id}/default.jpg"
            alt=""
            class="thumbnail lazy" />
          <img src="img/play-button.svg" alt="" class="play_button" />
        </div>
        <div class="content">
          <div class="top">
            <div class="quick_actions">
              <a href="#footer" on:click={scroll} class="subscribe">
                <img src="img/bell.svg" alt="" />
              </a>
            </div>
            <h2 class="video_title">{video.title}</h2>
          </div>
          <div class="middle">
            <p class="description">{video.description}</p>
            {#if !video.pdf}
              <Social {video} />
            {/if}
          </div>

          {#if video.pdf}
            <div class="bottom">
              <a
                href="pdf/{video.pdf}.pdf"
                target="_blank"
                class="button download">
                Download PDF
              </a>
              <Social {video} />
            </div>
          {/if}

          {#if video.related}
            <h3>Related articles</h3>
            <div class="related_grid">
              {#each video.related as related}
                <a
                  class="related"
                  href="https://wildwoodhealth.com/blog/{related.slug}/"
                  target="_blank">
                  <img
                    src="https://wildwoodhealth.com/wp-content/uploads{related.img}-300x158.jpg"
                    alt={related.title} />
                  <p class="title">{related.title}</p>
                </a>
              {/each}
            </div>
          {/if}

        </div>
      </div>
    {/each}
    <h3 class="more">New Videos Every Friday!</h3>
  </div>
</main>
<!-- <Footer /> -->
